#!/bin/sh
#passed in a single puppy-db entry, convert to a debian-db entry.
#20220817 first version.

mkdir -p /var/local/pkgget #somewhere to keep deb-db files.
CWD="$(pwd)"

if [ -f ./DISTRO_SPECS ];then
 #running in woofq.
 . ./DISTRO_SPECS
 . ./DISTRO_COMPAT_REPOS-${DISTRO_BINARY_COMPAT}-${DISTRO_COMPAT_VERSION}
 . ./DISTRO_PKGS_SPECS-${DISTRO_BINARY_COMPAT}-${DISTRO_COMPAT_VERSION}
 . ./PKGS_MANAGEMENT
else
 #running in easyos.
 . /etc/DISTRO_SPECS
 . /root/.packages/DISTRO_COMPAT_REPOS #v431
 . /root/.packages/DISTRO_PKGS_SPECS
 . /root/.packages/PKGS_MANAGEMENT
fi

#here are typical puppy-db entries:
#from Packages-oe-dunfell-official:
#alsa-lib-1.2.1.2-r9|alsa-lib|1.2.1.2-r9||BuildingBlock|2012K|dunfell|alsa-lib-1.2.1.2-r9-nocona-64.tar.xz|+gcc-runtime,+glibc|ALSA sound library|oe|dunfell||
#audacious-3.10.1-r9|audacious|3.10.1-r9||Multimedia;mediaplayer|2496K|dunfell|audacious-3.10.1-r9-nocona-64.tar.xz|+alsa-lib,+alsa-plugins,+dbus,+dbus-glib,+gcc-runtime,+glib-2,+glibc,+gtk+,+jack,+pulseaudio|audio player|oe|dunfell||
#from Packages-debian-bookworm-main:
#abe_1.1+dfsg-4|abe|1.1+dfsg-4||Fun;adventure|105K|pool/main/a/abe|abe_1.1+dfsg-4_amd64.deb|+abe-data&eq1.1+dfsg-4,+libc6&ge2.14,+libsdl-mixer1.2,+libsdl1.2debian&ge1.2.11|side-scrolling game named Abes Amazing Adventure|debian|bookworm|
#abiword_3.0.5|abiword|3.0.5||Document;layout|5133K|pool/main/a/abiword|abiword_3.0.5~dfsg-1_amd64.deb|+abiword-common&ge3.0.5,+gsfonts,+libabiword-3.0&ge3.0.5,+libc6&ge2.14,+libdbus-1-3&ge1.9.14,+libdbus-glib-1-2&ge0.78,+libgcc-s1&ge3.0,+libgcrypt20&ge1.8.0,+libglib2.0-0&ge2.16.0,+libgnutls30&ge3.7.0,+libgoffice-0.10-10&ge0.10.2,+libgsf-1-114&ge1.14.9,+libgtk-3-0&ge3.0.0,+libjpeg62-turbo&ge1.3.1,+libloudmouth1-0&ge1.3.3,+libots0&ge0.5.0,+libpng16-16&ge1.6.2-1,+librdf0&ge1.0.17,+libreadline8&ge6.0,+librevenge-0.0-0,+libsoup2.4-1&ge2.4.0,+libstdc++6&ge7,+libtelepathy-glib0&ge0.13.0,+libtidy5deb1&ge5.2.0,+libwmf0.2-7&ge0.2.8.4,+libwpd-0.10-10,+libwpg-0.3-3,+libxml2&ge2.7.4,+zlib1g&ge1.1.4|efficient featureful word processor with collaboration|debian|bookworm|

#here is a typical debian-db entry:
#Package: abiword
#Version: 3.0.5~dfsg-1
#Installed-Size: 5133
#Maintainer: Jonas Smedegaard <dr@jones.dk>
#Architecture: amd64
#Depends: abiword-common (>= 3.0.5~dfsg-1), gsfonts, libabiword-3.0 (>= 3.0.5~dfsg), libc6 (>= 2.14), libdbus-1-3 (>= 1.9.14), libdbus-glib-1-2 (>= 0.78), libgcc-s1 (>= 3.0), libgcrypt20 (>= 1.8.0), libglib2.0-0 (>= 2.16.0), libgnutls30 (>= 3.7.0), libgoffice-0.10-10 (>= 0.10.2), libgsf-1-114 (>= 1.14.9), libgtk-3-0 (>= 3.0.0), libjpeg62-turbo (>= 1.3.1), libloudmouth1-0 (>= 1.3.3), libots0 (>= 0.5.0), libpng16-16 (>= 1.6.2-1), librdf0 (>= 1.0.17), libreadline8 (>= 6.0), librevenge-0.0-0, libsoup2.4-1 (>= 2.4.0), libstdc++6 (>= 7), libtelepathy-glib0 (>= 0.13.0), libtidy5deb1 (>= 1:5.2.0), libwmf0.2-7 (>= 0.2.8.4), libwpd-0.10-10, libwpg-0.3-3, libxml2 (>= 2.7.4), zlib1g (>= 1:1.1.4)
#Recommends: abiword-plugin-grammar, aspell-en | aspell-dictionary, fonts-liberation, poppler-utils
#Description: efficient, featureful word processor with collaboration
#Homepage: http://www.abisource.com/
#Description-md5: 30063e6f0ad54b0bc4811f0becf40355
#Tag: implemented-in::c++, interface::graphical, interface::x11,
# role::program, scope::application, uitoolkit::gtk, use::editing,
# use::text-formatting, works-with-format::html, works-with-format::tex,
# works-with::text, x11::application
#Section: editors
#Priority: optional
#Filename: pool/main/a/abiword/abiword_3.0.5~dfsg-1_amd64.deb
#Size: 1334712
#MD5sum: 918644c61e57f56a99dfe1fbd9cefc5d
#SHA256: 5cad479d7a59c611a64204bbfef736daafcd5ebd9bc0e5713b48c340c945519f

#we need Packages.xz from the debian repo...
for PKGLISTSPEC in $PKG_DOCS_DISTRO_COMPAT  #see file DISTRO_COMPAT_REPOS*
do
 #ex: http.us.debian.org|http://http.us.debian.org/debian/dists/${DISTRO_COMPAT_VERSION}/main/binary-amd64/Packages.xz|Packages-debian-${DISTRO_COMPAT_VERSION}-main
 PKGLISTFILE="`echo -n "$PKGLISTSPEC" | cut -f 3 -d '|'`"
 PKGLISTURI="`echo -n "$PKGLISTSPEC" | cut -f 2 -d '|'`"
 [ -f /var/local/pkgget/${PKGLISTFILE} ] && continue
 cd /var/local/pkgget
 rxvt -name pet -bg orange -geometry 80x10 -e wget ${PKGLISTURI}
 sync
 DLFILE="${PKGLISTURI##*/}"
 case "$DLFILE" in
  *.bz2)
   xDLFILE="`basename $DLFILE .bz2`"
   bunzip2 $DLFILE
   RETSTAT=$?
  ;;
  *.gz)
   xDLFILE="`basename $DLFILE .gz`"
   gunzip $DLFILE
   RETSTAT=$?
  ;;
  *.xz)
   xDLFILE="`basename $DLFILE .xz`"
   unxz $DLFILE
   RETSTAT=$?
  ;;
 esac
 if [ $RETSTAT -ne 0 ];then
  echo "Deb DB package d/l failure"
  rm -f ./${xDLFILE}*
  exit 1
 fi
 #filter out utf-8 characters...
 iconv -c -f utf-8 -t ascii ${xDLFILE} > /tmp/${xDLFILE}
 mv -f /tmp/${xDLFILE} ./${xDLFILE}
 cd "$CWD"
done

#simplest case, a pup-db entry previously created by 'debdb2pupdb'...

#more difficult, a pup-db entry created by '0pre-oe' in woofq.
# it has a generic name that may match to multiple entries in deb 'Packages' file...




###end###
